<template>
  <div class="dashboard container is-fluid">
    <div class="columns">
      <div class="column is-full">
        <div class="tabs">
          <ul v-if="projects && projects.length > 0">
            <router-link
              v-for="project in projects"
              v-on:click="changeActiveProject(project)"
              :key="project.uuid"
              :to="{name: 'dashboard-project', params: {projectUUID: project.uuid }}"
              tag="li"
              active-class="is-active has-text-weight-bold"
            >
              <a>{{ project.title }}</a>
            </router-link>
          </ul>
          <ul>
            <!-- Hardcode ability to Add Projects -->
            <router-link
              :to="{name: 'dashboard-add_project'}"
              tag="li"
              active-class="is-active has-text-weight-bold"
            >
              <a>Add Project</a>
            </router-link>
          </ul>
        </div>
      </div>
    </div>
    <router-view />
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "vue-property-decorator";
import { Project } from "../services/arbalo_extensions/projects";
import { Route } from "vue-router";

@Component
export default class Dashboard extends Vue {
  get projects() {
    return this.$store.state.projects;
  }

  @Watch("$route")
  async changeActiveProject(to: Route, from: Route) {
    const project: Project = this.$store.getters.getProjectByUUID(
      to.params.projectUUID
    );
    if (project) {
      this.$store.commit("setActiveProject", project);
      await this.fetchInstances();
      await this.$store.dispatch("project/fetchClientsForActiveProject");
    }
  }

  private async fetchInstances() {
    await this.$store.dispatch("catalog/fetchInstances", {
      projectUUID: this.$store.state.activeProject.uuid
    });
  }

  private async mounted() {
    // If mounting with a projectUUID then loaded from the router and set the active project
    if (!this.$store.state.activeProject) {
      // Look for existing projects
      if (this.$store.state.projects.length > 0) {
        this.$store.commit("setActiveProject", this.$store.state.projects[0]);
      } else {
        await this.$store.dispatch("fetchProjects");
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.dashboard {
  margin-top: 20px;
}
</style>
